Merge "[Tizen.WebView] Add namespace summary"
[platform/core/csapi/tizenfx.git] / build.sh
index 6da5b28..66ecec2 100755 (executable)
--- a/build.sh
+++ b/build.sh
@@ -6,6 +6,15 @@ SCRIPT_DIR=$(dirname $SCRIPT_FILE)
 # Properties
 OUTDIR=$SCRIPT_DIR/Artifacts
 
+NUGET_CMD="mono $SCRIPT_DIR/tools/NuGet.exe"
+
+RETRY_CMD="$SCRIPT_DIR/tools/retry.sh"
+TIMEOUT_CMD="$SCRIPT_DIR/tools/timeout.sh"
+
+DOTNET_CMD="$RETRY_CMD $TIMEOUT_CMD 600 dotnet"
+
+RUN_BUILD="$DOTNET_CMD msbuild $SCRIPT_DIR/build/build.proj"
+RUN_BUILD_DUMMY="$DOTNET_CMD build $SCRIPT_DIR/build/build.dummy.csproj"
 
 
 usage() {
@@ -13,17 +22,14 @@ usage() {
   echo "    Options:"
   echo "        -h, --help            Show this usages message"
   echo "        -b, --build [module]  Build a module"
-  echo "        -f, --full            Build all modules in src/ directory. The module should be added in pkg/Tizen.NET.Private.sln"
+  echo "        -f, --full            Build all modules in src/ directory"
   echo "        -d, --dummy           Build dummy modules"
+  echo "        -p, --pack  [version] Make nuget packages"
   echo "        -c, --clean           Clean all artifacts"
 }
 
 cmd_clean() {
-  rm -fr $OUTDIR
-  LIST=$(find $SCRIPT_DIR -type d -a -name bin -o -name obj)
-  for d in $LIST; do
-    rm -fr $d
-  done
+  $RUN_BUILD /t:clean
 }
 
 cmd_build() {
@@ -31,20 +37,36 @@ cmd_build() {
     echo "No module specified."
     exit 1
   fi
-  dotnet build $SCRIPT_DIR/src/$1 --configuration=Release --output=$OUTDIR/bin
+  if [ -d /nuget ]; then
+    NUGET_SOURCE_OPT="/p:RestoreSources=/nuget"
+  fi
+  $RUN_BUILD /t:build /p:Project=$1 $NUGET_SOURCE_OPT
 }
 
 cmd_full_build() {
-  dotnet build $SCRIPT_DIR/pkg/Tizen.NET.Private.sln --configuration=Release --output=$OUTDIR/bin
-  nuget pack $SCRIPT_DIR/pkg/Tizen.NET.Private.nuspec -Symbols -NoPackageAnalysis -BasePath $OUTDIR -OutputDirectory $OUTDIR
-  nuget pack $SCRIPT_DIR/pkg/Tizen.NET.nuspec -Symbols -NoPackageAnalysis -BasePath $OUTDIR -OutputDirectory $OUTDIR
+  if [ -d /nuget ]; then
+    NUGET_SOURCE_OPT="/p:RestoreSources=/nuget"
+  fi
+  $RUN_BUILD /t:build $NUGET_SOURCE_OPT
+}
+
+cmd_pack() {
+  if [ -n "$1" ]; then
+    NUGET_VERSION_OPT="-Version $1"
+  fi
+
+  $NUGET_CMD pack $SCRIPT_DIR/pkg/Tizen.NET.Private.nuspec -Symbols -NoPackageAnalysis $NUGET_VERSION_OPT -BasePath $SCRIPT_DIR -OutputDirectory $OUTDIR
+  $NUGET_CMD pack $SCRIPT_DIR/pkg/Tizen.NET.nuspec -Symbols -NoPackageAnalysis $NUGET_VERSION_OPT -BasePath $SCRIPT_DIR -OutputDirectory $OUTDIR
 }
 
 cmd_dummy_build() {
-  dotnet build $SCRIPT_DIR/pkg/Tizen.NET.Dummy.csproj --configuration=Release
+  if [ -d /nuget ]; then
+    NUGET_SOURCE_OPT="/p:RestoreSources=/nuget"
+  fi
+  $RUN_BUILD_DUMMY $NUGET_SOURCE_OPT
 }
 
-OPTS=`getopt -o hcbfd --long help,clean,build,full,dummy -n 'build' -- "$@"`
+OPTS=`getopt -o hcbfpd --long help,clean,build,full,pack,dummy -n 'build' -- "$@"`
 if [ $? != 0 ] ; then echo "Failed parsing options." >&2 ; usage; exit 1 ; fi
 eval set -- "$OPTS"
 
@@ -53,6 +75,7 @@ FLAG_FULL=false
 FLAG_BUILD=false
 FLAG_CLEAN=false
 FLAG_DUMMY=false
+FLAG_PACK=false
 
 while true; do
   case "$1" in
@@ -60,16 +83,18 @@ while true; do
     -b|--build) FLAG_BUILD=true; shift ;;
     -f|--full) FLAG_FULL=true; shift ;;
     -d|--dummy) FLAG_DUMMY=true; shift ;;
+    -p|--pack) FLAG_PACK=true; shift ;;
     -c|--clean) FLAG_CLEAN=true; shift ;;
     --) shift; break ;;
     *) break ;;
   esac
 done
 
-if $FLAG_HELP; then usage; exit 1; fi
-if $FLAG_CLEAN; then cmd_clean; exit 1; fi
-if $FLAG_FULL; then cmd_full_build; exit 1; fi
-if $FLAG_BUILD; then cmd_build $@; exit 1; fi
-if $FLAG_DUMMY; then cmd_dummy_build; exit 1; fi
+if $FLAG_HELP; then usage; exit 0; fi
+if $FLAG_CLEAN; then cmd_clean; exit 0; fi
+if $FLAG_FULL; then cmd_full_build; exit 0; fi
+if $FLAG_BUILD; then cmd_build $@; exit 0; fi
+if $FLAG_PACK; then cmd_pack $@; exit 0; fi
+if $FLAG_DUMMY; then cmd_dummy_build; exit 0; fi
 
-usage;
\ No newline at end of file
+usage;